breed [cells cell]
breed [rules rule]
breed [heads head]
undirected-link-breed [borders border]
directed-link-breed [arrows arrow]


globals [program-loaded? q-state rule-count rt-tape lt-tape blank-symbol corner the-head the-active-cell at-index input transition-rules rule-table-pressed? input-pressed? first-run? rules-list flat-rules data-list]
cells-own [symbol]
rules-own [current-state new-state current-symbol new-symbol new-location  rule-counter]
heads-own [current-state current-symbol]

to startup
 setup

end
to setup
  ca
  set input  []
  set q-state 20
  let tape patches with [pycor = -4]
  let head-patch patches with [pycor = -5 and pxcor = 0]
  set blank-symbol "_"
  let initial-state blue
  
  ask head-patch [
    sprout-heads 1 [
      set shape "triangle" 
      set size 2 
      set current-state initial-state 

      set color current-state 
      
      ]
    
    ]
  set the-head turtle 0
  
  ask tape [ sprout-cells 1 [set shape "square" set color (gray - 2 - random 2) set symbol "_" set label symbol ]]
  

  
  ;create alan turing
  ask one-of tape with [pxcor = 4] [sprout-cells 1 [set size 1.2 set shape "person" set heading 0 fd 1 set color 135 set at-index 4]]
  set rt-tape []
  set lt-tape []
 
  set first-run? 1
end

to set-tape-symbols [#input]
  let sorted-cells sort-on [pxcor] cells with [pycor = -4]
  let i 0
  while [i < (length first #input - 1) ] [show item i first #input set i i + 1 ]
  ;[ ask item i sorted-cells [set symbol item i first #input set label item i first #input set color item i first #input ] set i i + 1 ]
  ;foreach sort-on [pxcor] cells [ ask ? [set symbol item i #input set label symbol set i i + 1]]
end

to make-rule-table [#rules #visible]
  set corner patch (min-pxcor + 2) (max-pycor - 1)
  let i 0 ;row counter
  let j 0 ;group counter
  let k 0
  foreach #rules [
      let q first ?
      let col1 item 1 ?
      let col2 item 2 ?
      let col3 item 3 ?
      let spacer 1.5
     
      ask corner [
        sprout-rules 1 [
          set rule-counter k set k k + 1
          set heading 90 fd 10 * j               ;move to correct group position
          if i mod 5 = 0 [ make-header ]
          set heading 180 fd (2  + (i mod 5) * spacer)
          set heading 90 
          set shape "circle" 
          set size 1 
          set color first q 
          if #visible = "hide" [ht]
          ;column one
          hatch-rules 1 [ 
            set rule-counter k set k k + 1
            fd 2
            set current-symbol 0
            set new-symbol item 1 col1
            set new-location last col1 
            set current-state first q
            set new-state first col1
            set color new-state
            set label (word new-symbol "-" new-location)
             if #visible = "hide" [ht]
          ]
          ;column two
           hatch-rules 1 [ 
            set rule-counter k set k k + 1
            fd 4
            set current-symbol 1
            set new-symbol item 1 col2
            set new-location last col2 
            set current-state first q
            set new-state first col2
            set color new-state
            set label (word new-symbol "-" new-location)
             if #visible = "hide" [ht]
          ] 
           ;column three      
          hatch-rules 1 [ 
            set rule-counter k set k k + 1
            fd 6
            set current-symbol "_"
            set new-symbol item 1 col3
            set new-location last col3 
            set current-state first q
            set new-state first col3
            set color new-state
            set label (word new-symbol "-" new-location)
            if #visible = "hide" [ht]
          ]
          set shape "triangle"
      ]
         
      ]
      if i mod 5 = 4 [set j j + 1 ] ;make multiple tables for longer rule sets 
      set i i + 1
   ]
end

to-report change 
  ifelse [current-state] of the-head = red 
     [ report (sentence "_" red "X") ]  
     [ let active-rule rules with [ current-state = [current-state] of the-head and current-symbol = [current-symbol] of the-head ]
       ask active-rule [ set size 1.5 wait .5]
       report (sentence [new-symbol] of active-rule [new-state] of active-rule [new-location] of active-rule)
     ]
end

to go
  read
  if slow? [wait .5]
  rite
  if slow? [wait .5]
  change-state-and-move
  if done? [stop]
end

to read
  set the-active-cell one-of turtles-on patch 0 -4
  ask the-head [set current-symbol [label] of the-active-cell set label current-symbol] 
end 

to rite
  ask the-active-cell [set label first change]
  ask the-head [set label "" ] ;but we leave current symbol set so that change procedure works
end

to change-state-and-move
  let new-q item 1 change
  let dir last change
  ask the-head [set current-state new-q set color current-state]
  move-tape dir
  ask rules [set size 1]
end

to-report done?
  ifelse [color] of the-head = red 
  [
   ask patch 0 -1 [sprout 1 [set color green set shape "check" set size 4 set label "DONE"]]
   report true
  ]
  
  [report false]
end


to move-tape [#dir]
  
if  #dir = "X"[ stop ] ;exit move-tape procedure

if #dir = "R"
[
  set rt-tape fput one-of [symbol] of cells-on patch max-pxcor -4 rt-tape 
  ask cells-on patch max-pxcor -4 [die] 
  ask cells [set  heading 90 fd 1 ]
  create-cells 1 [ 
      setxy min-pxcor -4 
      set shape "square"

      set color (gray - 2 - random 2) 
      ifelse  length lt-tape > 0
         [
          set symbol last lt-tape
          set lt-tape but-last lt-tape
          set label symbol  
         ] 
         [
           set symbol blank-symbol
           set label symbol 
    
         ]
  ]
  set at-index at-index + 1

]
 
 if #dir = "L"
[
  set lt-tape lput one-of [symbol] of cells-on patch min-pxcor -4 lt-tape 
  ask cells-on patch min-pxcor -4 [die] 
  ask cells [set  heading 270 fd 1 ]
  create-cells 1 [ 
      setxy max-pxcor -4 
      set shape "square"
      set color (gray - 2 - random 2) 
      ifelse  length rt-tape > 0
         [
          set symbol first rt-tape
          set rt-tape but-first rt-tape 
          set label symbol  
         ] 
         [
           set symbol blank-symbol
           set label symbol 
         ]
  ]

  set at-index at-index - 1

]

  ;This just allows us to hide the little figure so that he does wrap and destroy the illusion of a moving tape.
  if at-index >= max-pxcor or at-index <= min-pxcor [ask cells with [pycor = -3] [ht] ]
  if at-index <= max-pxcor and at-index >= min-pxcor [ask cells with [pycor = -3] [st] ]
end
 
 
;; extra stuff just to make things pretty

to change-head
  
  if count rules = 0 [ make-rule-table  [[[blue]   [blue 0 "R"]     [blue 1 "R"]   [green "_" "L"]] [[green]  [green 1 "L"]    [green 0 "L"]  [red "_" "X"]]]  "show" ] 
  ask heads [set color [color] of one-of sort-on [who] rules ]
end


to load-input
  let current-input read-from-string input-tape
  set rules-list first current-input
  set data-list last current-input
  make-rule-table rules-list "hide"
  set flat-rules []
  let i 0
  repeat length rules-list [set flat-rules sentence flat-rules item i rules-list set i i + 1]
  show flat-rules
  load-program-and-data
end 
to load-program-and-data
  let sorted-cells sort-on [pxcor] cells with [pycor = -4]
  let i 0
  foreach flat-rules [ 
    if i mod 4 != 0 [ ask item i sorted-cells [set color first ?] ]
    ask item i sorted-cells [ set rule-count i]
    wait .3
    set i i + 1
  ]
   ask item i sorted-cells [set size .5 set color gray ]
   set i i + 1
  foreach data-list [ 
    ask item i sorted-cells [set label ? set symbol ? set color gray] 
    set i i + 1
     wait .3
  ]
  repeat max-pxcor [ move-tape "R" wait .1 ]
end
;to save-new-state
;  let rule-row  (list (list q-state ) ( list sym0  state0  dir0) ( list sym1  state1 dir1) ( list sym_  state_  dir_))
;  let quintuple (list (list (list q-state  )( list 0) (list state0 )  ( list sym0) ( list dir0 ) ) (list (list q-state  ) ( list 1)(list state1 )  ( list sym1) ( list dir1 ) )(list (list q-state  ) ( list "_") (list state_ )  ( list sym_) ( list dir_ ) ))
;  set input lput rule-row input
;  show input
;  
;  foreach quintuple [output-show ?]
;
; 
; end

to read-program
  set the-active-cell one-of turtles-on patch 0 -4
  let i 0
  while [[size] of the-active-cell > .6  ] [ wait .5 ask rules with [ i = rule-counter] [st] move-tape "L" set the-active-cell one-of turtles-on patch 0 -4 set i i + 1 ]
  set program-loaded? 1
end

to make-header
      ;borders
      
      hatch 1  [ set breed turtles set heading 90 fd .75 set heading 180 fd 1 ht hatch 1 [ set heading 90 fd 8 create-border-with  myself] hatch 1 [ set heading 180 fd 8 create-border-with  myself]]
      ;header
      hatch 1 [set shape "zero" set heading 90 fd 2 set color white ]
      hatch 1 [set shape "one" set heading 90 fd 4 set color white ]
      hatch 1 [set shape "underscore" set heading 90 fd 6 set color white ]   
end 
@#$#@#$#@
GRAPHICS-WINDOW
165
185
1212
505
30
8
17.0
1
12
1
1
1
0
1
1
1
-30
30
-8
8
0
0
1
ticks
30.0

BUTTON
15
408
135
473
Reset
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
1088
450
1193
483
Tape right  >>
move-tape \"R\"
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
184
457
296
490
<<  Tape left
move-tape \"L\"
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

TEXTBOX
10
10
355
51
Universal Turing Machine
18
0.0
1

TEXTBOX
435
720
875
739
(current state, current tape symbol, new state, new symbol, direction of move) 
11
0.0
1

BUTTON
15
335
80
368
Go
ifelse  program-loaded? = 0 \n[user-message \"Please provide input\"]\n[go]
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SWITCH
1110
510
1213
543
slow?
slow?
1
1
-1000

TEXTBOX
57
32
302
58
The stored program computer
12
0.0
1

BUTTON
615
455
755
488
Change State of Head
change-head
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

INPUTBOX
165
110
915
175
input-tape
[[[[blue]   [blue 0 \"R\"]     [blue 1 \"R\"]   [green \"_\" \"L\"]] [[green]  [green 1 \"L\"]    [green 0 \"L\"]  [red \"_\" \"X\"]] ]  [0 0 0 1 1 1] ]
1
0
String

BUTTON
15
110
135
143
Setup
load-input
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
15
220
135
253
Make Table
read-program
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

TEXTBOX
165
575
880
593
[[[[blue]   [blue 0 \"R\"]     [blue 1 \"R\"]   [green \"_\" \"L\"]] [[green]  [green 1 \"L\"]    [green 0 \"L\"]  [red \"_\" \"X\"]] ]  [0 0 0 1 1 1] ]
11
0.0
1

TEXTBOX
165
520
845
566
* It is a little tricky to get the nesting of sq. brackets right. Right-click on the Note below to copy/paste rules that work. It would not be hard to encode these rules in binary ( ex. blue = 00110011). 
13
0.0
1

TEXTBOX
5
80
250
111
1) Load Rules and Data *
14
0.0
1

TEXTBOX
5
175
155
206
2) Read Tape / Create Rule Table
14
0.0
1

TEXTBOX
5
310
115
341
3) Go Once
14
0.0
1

BUTTON
80
335
135
368
Go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

TEXTBOX
220
50
775
96
Input include BOTH rules and data. Here, for simplicity, the rules are represented as text and the data as symbols 1 and 0. Typically, the rules are encoded into the same set of symbols used for the data. 
13
0.0
1

TEXTBOX
935
115
1205
160
The NetLogo model is a Universal Turing Machine (UTM). Any particular rule table and data that you enter are a specific Turing machine. \n
11
0.0
1

@#$#@#$#@

## WHAT IS IT?
In 1936 Alan Turing published a paper describing some fundamental limits to logic and  mathematics. In order to build his argument, he needed to create a rigorous and formal defintion of an algorithm.  An algorithm is the familiar, stepwise process that we take when we solve math problems, build proofs and use deductive logic. Turing was especially interested in whether algorithms reached a definite conclusion or whether they continued endlessly. 


In order to establish that some well defined questions are beyond the reach of a conclusive algorithm, Turing created a paper and pencil "machine".  Turing's hypothetical machine had an infinite tape, a head that reads and write to the tape, and a mechanism to move the tape right or left. The head could be in one of multiple states and the tape held various symbols from a small library of possible symbols. At each step The state of the head AND the particular symbol under the head at that point in time are used to look up a particular transition rule that instructs the head to write a new (or the keep the same) symbol, change (or remain in the same) state, and move the tape right or left. We can say this more compactly:  (q, sym) --> (q', sym', dir) q is the current state, sym is the current symbol. q', the new state, sym' the new symbol, and dir the direction to move the tape. It is clear from this that each logical step can be represented as a group (tuple) of five elements: A head state possibly changing to at new state, a symbol on the tape possibly changing to a new symbol and the potential shift in environment (the tape). 

These simple steps are the essense of computation and, as we have seen in the decades since Turing, a great deal can be accomplished with these steps. In fact, all of conventional mathematics can be produced from the variation, combination and accumulation of these tiny pieces of logic. But, almost ironically, this was not Turing's objective in his 1936 paper. He was motivated to demonstrate what this mechanical process COULLDN'T achieve. 

##What is a Universal Turing Machine?

A Universal Turing Machine (UTM) has a set of rules (U) that accepts as input (I) a second machine's set of rules (encoded in symbols--call these rules, T) AND data (more symbols). As the UTM runs it uses the rules that it receives, T, to operate on the data portion, D. We say that U runs T on D.

The UTM produces the same output that would have resulted from a simpler machine that simply had a rule table with the rules T and data D (T running on D). Because you can encode the rule table for ANY concievable machine as symbols, it is not unreasonable to consider that U could run U on U. since U can be both an active program and passive data.

This dual nature of algorithms turns out to be important as Turing builds his argument about the limits of what algoritms can do. 

## HOW TO USE IT

Easy as 1, 2,3.

This is a demonstration of the Universal Turing machine. It is possible to modify the rule table in the input field but it is a bit awkward. This model offers a simple illustration of Turing's obvious (in retrospect) observation that rules can be encoded as data and a single machine can be used to load, interpret and execute rules on data.  For Turing's purposes, this opens the door for accepting as data the rules themselves--the twisty bit that lies at the heart of his mathematical project.

Once it is understood that rules can be loaded and 

## THE LARGER CONTEXT

Turing paper was motivated by his interest in demonstrating the limits of what could be computed by the step-wise method of an algorithm. Creating a machine that could represent the whole class of "what can be computed" was a central part of Turing's argument. 

Each instance of a Turing machine (it's rules and input) can be considered a unique number. If it runs and halts, there is a mapping between the unique "number" that you started with and the final "number".

## THINGS TO TRY

1) Convert the Rule 5-tuples to binary.
2) Now, create a set of rules that can be read and modified (a program that treats itself as data)
3) Make the program that you built in step 2 capable of coherent human conversation. 

Find a way to distinguish Halt and Non-halting programs
Develop a procedure to concatenate stored programs and load them at setup.



## NETLOGO FEATURES

This model uses custom turtles for the table header, turles and links as arrows and labels. It also make extensive use of lists. There are no sophisticated programmming techniques employed. A great deal of effort and much of the code involves making the tape "infinite" (or as big as your computer's memory). This is a curious aspect of this program which raises the Universal question "Why?".  



## RELATED MODELS

This model series includes three NetLogo models: 
-- Simple Turing Machine--this model
        An introduction to the basic parts/terminology of the Turing machine)
-- Universal Turing Maching
	Illustration of a machine that accepts as input both program and data)
--A Turing Machine that accepts input from a CSV file
	This is the model to use to develop programs that run on the Turing machine


## CREDITS AND REFERENCES
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

check
false
0
Polygon -7500403 true true 55 138 22 155 53 196 72 232 91 288 111 272 136 258 147 220 167 174 208 113 280 24 257 7 192 78 151 138 106 213 87 182

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

hash
false
0
Polygon -7500403 true true 135 45 165 45 120 270 90 270
Polygon -7500403 true true 195 45 225 45 180 270 150 270
Rectangle -7500403 true true 75 105 240 120
Rectangle -7500403 true true 75 180 225 195

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

one
false
2
Rectangle -7500403 false false 135 45 150 270
Rectangle -955883 false true 135 45 150 270
Rectangle -7500403 false false 120 45 135 60
Rectangle -955883 false true 105 255 180 270
Line -7500403 false 135 60 150 60
Rectangle -955883 true true 135 45 150 270
Rectangle -955883 true true 120 45 150 60
Rectangle -955883 true true 105 255 180 270
Rectangle -955883 true true 120 60 135 75
Rectangle -955883 true true 105 60 120 75
Rectangle -955883 true true 90 240 195 270
Circle -16777216 true false 180 225 30
Circle -16777216 true false 75 225 30
Rectangle -955883 true true 120 45 105 60
Rectangle -955883 true true 105 45 120 75
Rectangle -955883 true true 90 45 105 75
Circle -16777216 true false 75 30 30

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

two
false
0
Circle -7500403 true true 75 15 150
Polygon -7500403 true true 90 60 150 30 150 45 105 75 90 60 150 30
Rectangle -7500403 true true 150 30 150 45
Polygon -7500403 true true 225 75 225 135 210 135 210 90 225 75
Polygon -7500403 true true 225 135 150 195 150 180
Polygon -7500403 true true 210 135 150 180 225 135
Polygon -7500403 true true 150 180 90 255 120 255 150 195
Polygon -7500403 true true 105 255 225 255 225 240 120 240
Polygon -7500403 true true 150 30 210 45 225 75 210 90 195 60 150 45
Polygon -7500403 true true 135 240 225 135 150 195 120 240 135 240
Polygon -7500403 true true 210 135 210 90 180 150
Polygon -7500403 true true 150 45 120 60 195 60 150 45
Rectangle -7500403 true true 120 225 240 255
Polygon -7500403 true true 195 135 150 180 210 135
Polygon -7500403 true true 105 75 90 90 75 75 90 60
Polygon -7500403 true true 90 90 105 90 105 75
Rectangle -7500403 true true 90 60 210 120
Circle -7500403 true true 105 75 30
Circle -16777216 true false 150 90 30
Circle -16777216 true false 108 63 85
Polygon -16777216 true false 120 120 75 120 120 180 165 165 195 105
Polygon -7500403 true true 135 195 90 225 90 255
Rectangle -7500403 true true 75 225 105 255

underscore
false
0
Rectangle -7500403 true true 0 225 300 270

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

zero
false
0
Circle -7500403 true true 16 16 268
Rectangle -16777216 true false 0 0 30 315
Rectangle -16777216 true false 270 0 330 300
Rectangle -16777216 true false 105 105 195 195
Circle -16777216 true false 89 44 122
Circle -16777216 true false 90 135 120
Rectangle -16777216 true false 90 120 210 195

@#$#@#$#@
NetLogo 5.0.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Polygon -7500403 true true 150 0 105 75 195 75 150 0

arrow
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 0 105 75
Line -7500403 true 150 0 195 75
Line -7500403 true 105 75 195 75
Polygon -7500403 true true 150 0 105 75 195 75

@#$#@#$#@
1
@#$#@#$#@
